/*
 * TournamentSelection.hpp
 *
 *  Created on: Feb 22, 2015
 *      Author: Joost Huizinga
 */

#ifndef SEL_TOURNAMENTSELECTION_HPP_
#define SEL_TOURNAMENTSELECTION_HPP_

#include "Misc_Random.hpp"

class TournamentSelector{
    public:
    TournamentSelector(size_t tournamentSize = 2, bool eletism = true):
        _tournamentSize(tournamentSize), _elitism(eletism){

    }

    /**
     * Implement such that nrToSelect individuals are selected according to tournament selection.
     *
     * This means that nrToSelect tournaments are held.
     * For each tournament, select _tournamentSize individuals uniform randomly from the population
     * (the same individual may be selected multiple times).
     * From the randomly selected individuals, select the individual with the highest performance
     * (ties can be broken arbitrarily).
     *
     * If _eletism is true, first add the best individual of the population,
     * then select the next nrToSelect - 1 individuals normally.
     */
    template<typename Indiv>
    std::vector<Indiv> select(std::vector<Indiv>& population, size_t nrToSelect){
        /* TODO: YOUR CODE HERE */

    }

    /**
     * Overloaded version of select.
     *
     * Implement such that it selects a number of individual equal to the population size.
     */
    template<typename Indiv>
    std::vector<Indiv> select(std::vector<Indiv>& population){
        /* TODO: YOUR CODE HERE */
 
    }

    /**
     * Overloaded version of select.
     *
     * Implement such that the parent and child population are first added to a single vector,
     * then call select(std::vector<Indiv>& population, size_t nrToSelect) to select a number
     * of individuals equal to the size of the original population (not the mixed population).
     */
    template<typename Indiv>
    std::vector<Indiv> select(std::vector<Indiv>& population, std::vector<Indiv>& children){
        /* TODO: YOUR CODE HERE */

    }

private:
    size_t _tournamentSize;
    bool _elitism;
};


#endif /* SEL_TOURNAMENTSELECTION_HPP_ */
